# PCA is an efficient tool for time series reduction

This is the official repo for PCA is an efficient tool for time series reduction. 

## Getting Started

1. Install Python >= 3.6, and install the dependencies by:

```
pip install -r requirements.txt
```

2. You can obtain all the datasets for forecasting and classification from [[Google Drive]](https://drive.google.com/drive/folders/13Cg1KYOlzM5C7K8gK8NfC-F3EYxkM3D2?usp=sharing), [[Tsinghua Cloud]](https://cloud.tsinghua.edu.cn/f/84fbc752d0e94980a610/) or [[Baidu Drive]](https://pan.baidu.com/s/1r3KhGd0Q9PJIUZdfEYoymg?pwd=i9iy) provided in TimesNet and put them into the folder `./dataset`, and the datasets for regression are already in the folder `./dataset`. 

3. You can reproduce the experiment results through the training scripts `./scripts/`,you can choose to use the original series or PCA series by adjusting the comments in run.py

```
# forecasting
bash ./scripts/forecasting/Linear_ETTh1.sh
# regression
bash ./scripts/regression/Linear.sh
```

## Acknowledgement

We appreciate the following repos for their valuable code base or datasets:

https://github.com/thuml/Time-Series-Library

https://github.com/cure-lab/LTSF-Linear
